Safe Haskell | Safe

PatternSyns

Description

Testing some pattern synonyms

Synopsis

- data FooType x = FooCtor x
- pattern Foo :: forall t. t -> FooType t
- pattern Bar :: forall t. t -> FooType (FooType t)
- pattern (:<->) :: forall t t1. t -> t1 -> (FooType t, FooType (FooType t1))
- data a >< b = Empty
- pattern E :: forall k t t1. (><) k t t1

# Documentation

data FooType x #

FooType doc

Constructors

FooCtor x |

pattern Foo :: forall t. t -> FooType t #

Pattern synonym for `Foo` x

pattern Bar :: forall t. t -> FooType (FooType t) #

Pattern synonym for `Bar` x

pattern (:<->) :: forall t t1. t -> t1 -> (FooType t, FooType (FooType t1)) #

Pattern synonym for (`:<->`)

data a >< b #

Doc for (`><`)

Constructors

Empty |

pattern E :: forall k t t1. (><) k t t1 #

Pattern for `Empty`